//-----------------------------------------------------------------------
// OpenGL 'Ghost' by Andreas Gustafsson (Shadow/Noice) (C)2000
//-----------------------------------------------------------------------
#include "stdafx.h"
#include "Texture.h"

#define NRDIVS 32

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "Ghost by Andreas Gustafsson (Shadow/Noice) (C) 2000";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;

// Current window dimensions.
extern GLsizei g_w, g_h;

// Use the demonstration texture.
CTexture gTexExample;
CTexture gTexExample2;

float height[NRDIVS+1][NRDIVS+1];

// Startup Stuff.
bool Init()	// Called right after the window is created, and OpenGL is initialized.
{
	int i,j;
	
	glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(55.0, (GLfloat) g_w/(GLfloat) g_h, 1.0, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef (0.0, 0.0, -5.0);
	glClearColor(0.0,0.0,0.0,0.0);

	gTexExample.LoadJPG("o021.jpg");
	gTexExample2.LoadJPG("flesh.jpg");
	glEnable( GL_TEXTURE_2D );

	for(i=0;i<=NRDIVS;i++)
	{
		for(j=0;j<=NRDIVS;j++)
		{
			height[i][j]=0;
		}
	}
	return true;
}

void Shutdown() // Called right after the window is destroyed.
{
}

void drawFlag()
{
	int x,y;
	float xp,yp;

	glBegin(GL_TRIANGLES);
	for(x=0;x<NRDIVS;x++)
	{
		for(y=0;y<NRDIVS;y++)
		{
			xp=-2.0f+x*(4.0f/NRDIVS);
			yp=-2.0f+y*(4.0f/NRDIVS);
			glColor4f(1,1,1,0.7f+height[x][y]);
			glTexCoord2f( x*(1.0f/NRDIVS), y*(1.0f/NRDIVS) );
			glVertex3f(xp,yp,height[x][y]);
			glColor4f(1,1,1,0.7f+height[x+1][y]);
			glTexCoord2f((x+1)*(1.0f/NRDIVS), y*(1.0f/NRDIVS) );
			glVertex3f(xp+(4.0f/NRDIVS),yp,height[x+1][y]);
			glColor4f(1,1,1,0.7f+height[x][y+1]);
			glTexCoord2f( x*(1.0f/NRDIVS), (y+1)*(1.0f/NRDIVS));
			glVertex3f(xp,yp+(4.0f/NRDIVS),height[x][y+1]);
			glColor4f(1,1,1,0.7f+height[x+1][y]);
			glTexCoord2f( (x+1)*(1.0f/NRDIVS), y*(1.0f/NRDIVS) );
			glVertex3f(xp+(4.0f/NRDIVS),yp,height[x+1][y]);
			glColor4f(1,1,1,0.7f+height[x][y+1]);
			glTexCoord2f( x*(1.0f/NRDIVS), (y+1)*(1.0f/NRDIVS));
			glVertex3f(xp,yp+(4.0f/NRDIVS),height[x][y+1]);
			glColor4f(1,1,1,0.7f+height[x+1][y+1]);
			glTexCoord2f( (x+1)*(1.0f/NRDIVS), (y+1)*(1.0f/NRDIVS));
			glVertex3f(xp+(4.0f/NRDIVS),yp+(4.0f/NRDIVS),height[x+1][y+1]);
		}
	}
	glEnd();

}


// Draw all the scene related stuff.
void Render()
{
	int x,y;

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	gTexExample.Use(); // Tells OpenGL to use this texture.
	glEnable( GL_TEXTURE_2D );
	glPushMatrix();
	glRotatef( fTime*-8 ,0,0, 1.f );
	glScalef( 5.0f, 5.0f, 5.0f );
	glBegin( GL_QUADS );
	glTexCoord2f(0,0);
	glVertex2d(-1,-1);
	glTexCoord2f(2,0 );
	glVertex2d(1,-1);
	glTexCoord2f(2, 2);
	glVertex2d(1,1);
	glTexCoord2f(0,2);
	glVertex2d(-1,1);
	glEnd();
	
	glPopMatrix();
	glPushMatrix();
	glEnable(GL_BLEND);
	gTexExample2.Use(); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glRotatef((float)(5*sin(fTime*0.25)),1,0,0);
	glRotatef((float)(5*sin(fTime*0.1f)),0,1,0);
	glRotatef((float)(30*sin(fTime*-0.45f)),0,0,1);

	for(x=0;x<=NRDIVS;x++)
	{
		for(y=0;y<=NRDIVS;y++)
		{
			height[x][y]=(float)(0.7*sin(x*0.3+fTime*0.9)*0.5*sin(y*0.5+fTime*0.6));
		}
	}

	glScalef(1.0,1.0,3.0);
	drawFlag();

	glPopMatrix();
	glDisable(GL_BLEND);
}
